// * Copyright (C) December 1995, ATI Technologies Inc.

#ifndef __PARM_H
#define __PARM_H

// Parameter types as character (same meaning as above)
#define DTC_END                 '\x00'
#define DTC_PTR                 '\x01'
#define DTC_I2                  '\x02'
#define DTC_I4                  '\x03'
#define DTC_I8					'\x04'
#define DTC_NONE				DTC_END
#define DTC_CHAR				DTC_I2
#define DTC_BYTE				DTC_I2
#define DTC_BOOL				DTC_I2
#define DTC_HWND				DTC_I2
#define DTC_HANDLE				DTC_I2
#define DTC_RGB					DTC_I4
#define DTC_SHORT				DTC_I2
#define DTC_INT					DTC_I2
#define DTC_WORD				DTC_I2
#define DTC_WPARAM				DTC_I2
#define DTC_DWORD				DTC_I4
#define DTC_LPARAM				DTC_I4
#define DTC_LRESULT				DTC_I4
#define DTC_FLOAT				DTC_I4
#define DTC_DOUBLE				DTC_I8

#define MAX_REFS                11
#define MAX_VALS                50


#ifdef __cplusplus
extern "C" {
#endif  

// These are the names of the DLL's that the thunking layer connects.
// If you change these you should also change the DLL name in parm16.def
// and the DLL name in the version information in parm32.rc.
// Of course you would also have the rename the .DLL files to match the
// new names as well.
#define DLL16NAME	"dva16.dll"
#define DLL32NAME	"dva32.dll"


// Public functions
#ifdef WIN32
//	#ifdef DLLEXPORT
//		#define DLLINT __declspec(dllexport)
//	#else
//		#define DLLINT __declspec(dllimport)
//	#endif
void (WINAPIV *Invoke16Func) (short,unsigned long*,BYTE [],...);
	
//	DLLINT void WINAPIV Invoke16Func(short sDispCode, unsigned long *pulError, BYTE abyParms[], ...);
#else
	// Structures used to place data on the stack
	struct tagLong
	{
		WORD wHi;
		WORD wLo;
	};
	
	struct tagDouble
	{   
		struct tagLong dwHi;
		struct tagLong dwLo;
	};                       
	
	// Function dispatch type
	typedef unsigned long (FAR PASCAL _export *MMMM_DISPPROC)();
	
	// Function dispatch table type
	typedef struct MMMM_tagDispMap
	{
		short sDispCode;
		MMMM_DISPPROC lpfnProc;
	} MMMM_DISPMAP;
	
	// Macro's to define the dispatch table
	#define BEGIN_DISPTABLE MMMM_DISPMAP MMMM_astDispMap[] = {
	#define DISP_FUNCTION(x,y) {x,(MMMM_DISPPROC) y},
	#define END_DISPTABLE {-1,(MMMM_DISPPROC)NULL}};
	#define GETDISPTABLE MMMM_astDispMap
	
	// Point to the one and only dispatch map
	extern MMMM_DISPMAP MMMM_astDispMap[];

#endif

int CALLBACK Call32( short sDispCode, DWORD Parm0, DWORD Parm1, DWORD Parm2,
				DWORD Parm3, DWORD Parm4, 
				unsigned long *pulError);

int CALLBACK Call16( short sDispCode, LPVOID lpvParm0, LPVOID lpvParm1, LPVOID lpvParm2,
				LPVOID lpvParm3, LPVOID lpvParm4, LPVOID lpvParm5, LPVOID lpvParm6, 
				LPVOID lpvParm7, LPVOID lpvParm8, LPVOID lpvParm9, LPVOID lpvParm10,
				LPBYTE abyParms, unsigned long *pulError);

#ifdef __cplusplus
}
#endif

#endif /* __PARM_H */