VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cldCCFactory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'--------------------------------------------------------------------------------------------------=
'    Written/copyright 2000 by Eiji Sakai (sake@istar.ca)
'
'    This software may be used and distributed according to the terms
'    of the GNU Public License.
'
'    This program allows you to improve your listening in the languages
'    you want to learn.
'
'    Support and updates available at
'    http://www.istar.ca/~sake/
'--------------------------------------------------------------------------------------------------=

Dim starttime As Single
Dim state As Long
Dim buff As String
Dim mode As Long
Dim fno As Long
Dim lno As Long 'line no
Dim lines As Collection
Dim linebuff As String
Dim checks As Collection

'Working variables
Dim phigh As Long
Dim plow As Long
Dim savedBuff As String

Const CC_INVSPACE = &HA0
Const CC_BAD = &H87

Const CF_MAX_LEN = 1000
Const CF_OPEN = 1
Const CF_CLOSED = 2
Const CF_BUFFERED1 = 3
Const CF_BUFFERED2 = 4

Const SCR_MODE_ROLL = 1
Const SCR_MODE_POP = 2
Const SCR_MODE_PAINT = 3

' the following are valid codes for the iso01mod-8x16 font
Const TMSYM = &H9F
Const MUSNOTE = &H9E
Const BLOCK = &H88

Public Sub init(fno_ As Long)
    If fno <> 0 Then
        flushLines
    End If

    starttime = Timer
    state = CF_CLOSED
    buff = ""
    mode = 0
    fno = fno_
    lno = 0
    Set lines = New Collection
    Set checks = New Collection
    
    phigh = 0
    plow = 0
    linebuff = ""
End Sub

Private Sub putchar(ch As Long)
    Select Case state
        Case CF_CLOSED
            state = CF_BUFFERED1
        Case CF_OPEN
            state = CF_BUFFERED2
    End Select
    buff = buff & Chr(ch)
End Sub

Private Function getTime() As Long
    getTime = Int((Timer - starttime) * 100)
End Function

Private Sub flushSavedBuff()
    Print_ Trim$(savedBuff)
    savedBuff = ""
End Sub

Private Sub saveBuff()
    savedBuff = buff
    buff = ""
End Sub

Private Sub signalErase()
    Dim t As Long
    t = getTime
    Select Case state
    Case CF_OPEN
        Print_ CStr(t)
        Print_ vbTab
        flushSavedBuff
        PrintCRLF
        state = CF_CLOSED
    Case CF_BUFFERED1, CF_BUFFERED2
        If state = CF_BUFFERED2 Then
            Print_ CStr(t)
            Print_ vbTab
            flushSavedBuff
            PrintCRLF
        End If
        Print_ t & vbTab
        saveBuff
        state = CF_OPEN
    End Select
End Sub

Private Sub Print_(msg As String)
    Debug.Print msg;
    If fno <> 0 Then
        'Print #fno, msg;
        If linebuff = "" Then
            lno = lno + 1
        End If
        linebuff = linebuff & msg
    End If
End Sub

Private Sub PrintCRLF()
    Debug.Print
    If fno <> 0 Then
        'Print #fno, ""
        lines.Add linebuff
        linebuff = ""
    End If
End Sub

Private Sub flushLines()
    Dim i As Long
    
    For i = 1 To lines.Count
        On Error Resume Next
        Print #fno, lines.Item(i);
        On Error Resume Next
        'the line is checked?
        'Take into account some delay
        checks.Item CStr(i + 1)
        If Err.Number = 0 Then
            Print #fno, vbTab & "1"
        Else
            Print #fno, ""
        End If
        'Debug.Print "output = " & lines.Item(i)
    Next
End Sub

Public Sub check()
    On Error GoTo ErrHandler
    checks.Add 1, CStr(lno)
    Debug.Print vbCrLf & "Check!! lno = " & lno
ErrHandler:
End Sub


 ' This function was originally written by Chrisitan Lupien
 '   (lupien@physics.utoronto.ca) in the GATO project.
Public Sub decode(ByVal high As Long, ByVal low As Long)
  Dim ch As Long
 
  If high >= &H10 And high <= &H1F Then
    If low < &H20 Or low > &H7F Then
        phigh = 0
        plow = 0
        Exit Sub
    End If
    If low = plow And high = phigh Then
        phigh = 0
        plow = 0
        Exit Sub
    End If
    phigh = high
    plow = low
    Call control(high, low)
    Exit Sub
  End If
  
  If high = &HFF And low = plow Then
    phigh = 0
    plow = 0
    Exit Sub
  End If
  phigh = 0
  plow = 0
  If high > &HF Then
    If mode = SCR_MODE_POP Then
        ch = cfilter(high, 0)
        Call putchar(ch)
    End If
  End If
  If low >= &H20 Then
    If mode = SCR_MODE_POP Then
        ch = cfilter(low, 0)
        Call putchar(ch)
    End If
  End If

End Sub

' This function was originally written by Chrisitan Lupien
'   (lupien@physics.utoronto.ca) in the GATO project.
Private Sub control(high As Long, low As Long)
    If (low >= &H40 And low <= &H4E) Or _
       (low >= &H50 And low <= &H5F) Or _
       (low >= &H60 And low <= &H6E) Or _
       (low >= &H70 And low <= &H7F) Then
       Call putchar(Asc(" "))
       Exit Sub
    End If
    
    If high = &H14 Or high = &H1C Then
        Select Case low
            Case &H20
                mode = SCR_MODE_POP
            Case &H25, &H26, &H27
                mode = SCR_MODE_ROLL
            Case &H29
                mode = SCR_MODE_PAINT
            Case &H2C
                If mode = SCR_MODE_POP Then
                    Call signalErase
                End If
        End Select
    End If
End Sub

 ' This function was originally written by Chrisitan Lupien
 '   (lupien@physics.utoronto.ca) in the GATO project.
Private Function cfilter(c As Long, alt As Long) As Long
    Dim r As Long
 ' assuming iso 8859-1 set
    If alt <> 0 Then
        Select Case c
            Case &H30
                r = &HAE
            Case &H31
                r = &HB0
            Case &H32
                r = &HBD
            Case &H33
                r = &HBF
            Case &H34
                r = TMSYM
            Case &H35
                r = &HA2
            Case &H36
                r = &HA3
            Case &H37
                r = MUSNOTE
            Case &H38
                r = &HE0
            Case &H39
                r = CC_INVSPACE
            Case &H3A
                r = &HE8
            Case &H3B
                r = &HE2
            Case &H3C
                r = &HEA
            Case &H3D
                r = &HEE
            Case &H3E
                r = &HF4
            Case &H3F
                r = &HFB
            Case Else
                r = CC_BAD
        End Select
    ElseIf c < &H20 Or &H7F < c Then
        r = CC_BAD
    Else
        Select Case c
            Case &H23
                r = Asc("#")
            Case &H2A
                r = &HE1
            Case &H5C
                r = &HE9
            Case &H5E
                r = &HED
            Case &H5F
                r = &HF3
            Case &H60
                r = &HFA
            Case &H7B
                r = &HE7
            Case &H7C
                r = &HF7
            Case &H7D
                r = &HD1
            Case &H7E
                r = &HF1
            Case &H7F
                r = BLOCK
            Case Else
                r = c
        End Select
     End If
     cfilter = r
End Function

