Attribute VB_Name = "modMain"
Option Explicit

'--------------------------------------------------------------------------------------------------=
'    Written/copyright 2000 by Eiji Sakai (sake@istar.ca)
'
'    This software may be used and distributed according to the terms
'    of the GNU Public License.
'
'    This program allows you to improve your listening in the languages
'    you want to learn.
'
'    Support and updates available at
'    http://www.istar.ca/~sake/
'--------------------------------------------------------------------------------------------------=

Public Declare Function mciSendString Lib "winmm.dll" Alias _
                         "mciSendStringA" (ByVal lpstrCommand As String, ByVal _
                         lpstrReturnString As Any, ByVal uReturnLength As Long, ByVal _
                         hwndCallback As Long) As Long

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" _
    (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, _
    ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Declare Function WritePrivateProfileString Lib "kernel32" _
    Alias "WritePrivateProfileStringA" (ByVal lpApplicationName _
    As String, ByVal lpKeyName As Any, ByVal lpString As Any, _
    ByVal lpFileName As String) As Long

Declare Function GetPrivateProfileString Lib "kernel32" _
    Alias "GetPrivateProfileStringA" (ByVal lpApplicationName _
    As String, ByVal lpKeyName As Any, ByVal lpDefault As String, _
    ByVal lpReturnedString As String, ByVal nSize As Long, ByVal _
    lpFileName As String) As Long

Public g_lMciRes As Long
Public g_SaveDir As String
Public g_CCFactory As cldCCFactory
Private m_sIniFileName As String

Public Sub Main()
    m_sIniFileName = MakePath$(App.Path, App.EXEName & ".ini")
    g_SaveDir = GetProfile("SaveDir", App.Path)
    Set g_CCFactory = New cldCCFactory
    Call g_CCFactory.init(0)
    frmMain.Show
End Sub

Public Function GetProfile(sKey As String, Optional sDefault As String) As String
    Dim Temp As String * 50
    Dim sAppName As String, lpFileName As String
    Call GetPrivateProfileString("global", sKey, sDefault, Temp, Len(Temp), m_sIniFileName)
    GetProfile = TrimEx(Temp)
End Function

Public Function WriteProfile(sKey As String, sValue As String) As String
    Call WritePrivateProfileString("global", sKey, sValue, m_sIniFileName)
End Function

Public Function MCICommand(cmd As String) As String
 Dim RS As String, cb As Long
 Dim tmp As String
 
 RS = Space$(128)
 g_lMciRes = mciSendString(cmd, RS, 128, cb)
 tmp = Trim$(RS)
 MCICommand = Left$(tmp, Len(tmp) - 1)
End Function

Public Function MakePath$(ByVal drv$, ByVal subdir$)

    Do While Right$(drv$, 1) = "\"
    drv$ = Left$(drv$, Len(drv$) - 1)
    Loop
    
    Do While Left$(subdir$, 1) = "\"
    subdir$ = Mid$(subdir, 2)
    Loop
    
    MakePath$ = drv$ + "\" + subdir$

End Function

'Strip characters whose code is under 32 on the both sides
Public Function TrimEx(ByVal s As String) As String
    Do While Len(s) > 0
        If Asc(Right$(s, 1)) < 32 Then
            s = Left$(s, Len(s) - 1)
        Else
            Exit Do
        End If
    Loop
    
    Do While Len(s) > 0
        If Asc(Left$(s, 1)) < 32 Then
            s = Mid$(s, 2)
        Else
            Exit Do
        End If
    Loop
    TrimEx = s
End Function


Public Function HiWord(ByVal x As Long) As Long
    HiWord = (x And &HFFFF0000) / 65536
End Function

Public Function LoWord(ByVal x As Long) As Long
    LoWord = x - HiWord(x) * 65536
End Function


