Attribute VB_Name = "modVid"
Option Explicit

'--------------------------------------------------------------------------------------------------=
'    Written/copyright 2000 by Eiji Sakai (sake@istar.ca)
'
'    This software may be used and distributed according to the terms
'    of the GNU Public License.
'
'    This program allows you to improve your listening in the languages
'    you want to learn.
'
'    Support and updates available at
'    http://www.istar.ca/~sake/
'--------------------------------------------------------------------------------------------------=

Public Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" _
 (ByVal dwExStyle As Long, _
 ByVal lpClassName As String, _
 ByVal lpWindowName As String, _
 ByVal dwStyle As Long, _
 ByVal x As Long, _
 ByVal y As Long, _
 ByVal nWidth As Long, _
 ByVal nHeight As Long, _
 ByVal hWndParent As Long, _
 ByVal hMenu As Long, _
 ByVal HINSTANCE As Long, _
 lpParam As Any) As Long
 
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
 (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Public Declare Function GetLastError Lib "kernel32" () As Long

Public Declare Function SetWindowPos Lib "user32" _
(ByVal hwnd As Long, ByVal hWndInsertAfter As Long, _
ByVal x As Long, ByVal y As Long, ByVal cx As Long, _
ByVal cy As Long, ByVal wFlags As Long) As Long

Public Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, _
    ByVal nCmdShow As Long) As Long
    
Public Declare Function DVALoad Lib "atitv" (ByVal HINSTANCE As Long) As Long
Public Declare Sub DVAFree Lib "atitv" ()
Public Declare Function DVAAudioSetVolume Lib "atitv" _
    (ByVal wCard As Integer, ByVal wVolume As Integer) As Long
Public Declare Sub DVASetProperty Lib "atitv" _
    (ByVal wCard As Integer, ByVal wProperty As Integer, ByVal dwNewValue As Long)
Public Declare Function DVATuneSetChannel Lib "atitv" _
    (ByVal wCard As Integer, ByVal wChannel As Integer) As Integer
Public Declare Function DVATuneScan Lib "atitv" _
    (ByVal wCard As Integer, ByVal lpfnCallback As Long) As Integer
Public Declare Function DVATuneChannels Lib "atitv" _
    (ByVal wCard As Integer) As Long

Public Const WS_CHILD = &H40000000
Public Const WS_VISIBLE = &H10000000
Public Const BS_LEFTTEXT = &H20&
Public Const WS_CLIPSIBLINGS = &H4000000
Public Const WS_CLIPCHILDREN = &H2000000
Public Const WM_USER = &H400
Public Const SWP_NOZORDER = &H4

Public Const SW_HIDE = 0
Public Const SW_SHOW = 5

Public Const DVA_START_DISPLAY = WM_USER + 3   ' Begin transferring frames,
Public Const DVA_STOP_DISPLAY = WM_USER + 4
Public Const DVA_PAUSE = WM_USER + 11
Public Const DVA_SETCC = WM_USER + 16
Public Const DVA_CCCALLBACK = WM_USER + 43

Public Const kDConnector = 12

Public Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Public g_bChannels() As Boolean
Public g_nMaxChannel As Long
Public g_nCurrentChannel As Long

Public Function TunerScanCallback(ByVal wCurrent As Integer, ByVal wMaximum As Integer, _
    ByVal wFound As Integer) As Integer
    If wFound <> 0 And wCurrent <= g_nMaxChannel Then
        g_bChannels(wCurrent) = True
    End If
    Debug.Print "TunerScanCallBack wCurrent = " & wCurrent & ", wFound = " & wFound
    TunerScanCallback = Abs(True)
End Function

Public Function VidCreateWindow(hwnd As Long, hinst As Long, r As RECT) As Long
    VidCreateWindow = CreateWindowEx(0, "ATIVideoWindow", "", _
                WS_CHILD Or WS_VISIBLE Or WS_CLIPSIBLINGS Or WS_CLIPCHILDREN, _
                r.Left, r.Top, _
                r.Right - r.Left, r.Bottom - r.Top, _
                hwnd, 0, hinst, 0)
End Function

Public Function VidStartDisplay(hwnd As Long) As Long
    VidStartDisplay = SendMessage(hwnd, DVA_START_DISPLAY, 0, 0)
End Function

Public Function VidStopDisplay(hwnd As Long) As Long
    VidStopDisplay = SendMessage(hwnd, DVA_STOP_DISPLAY, 0, 0)
End Function

Public Function VidPause(hwnd As Long, state As Boolean) As Long
    VidPause = SendMessage(hwnd, DVA_PAUSE, Abs(state), 0)
End Function

Public Function VidSetCC(hwnd As Long, hwndHook As Long, dwID As Long) As Long
    VidSetCC = SendMessage(hwnd, DVA_SETCC, hwndHook, dwID)
End Function

