Attribute VB_Name = "modWndproc"
Option Explicit

'--------------------------------------------------------------------------------------------------=
'    Written/copyright 2000 by Eiji Sakai (sake@istar.ca)
'
'    This software may be used and distributed according to the terms
'    of the GNU Public License.
'
'    This program allows you to improve your listening in the languages
'    you want to learn.
'
'    Support and updates available at
'    http://www.istar.ca/~sake/
'--------------------------------------------------------------------------------------------------=

Public gVideo As Long

Private Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hwnd As Long, _
    ByVal lpString As String) As Long

Private Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hwnd As Long, _
    ByVal lpString As String, ByVal hData As Long) As Long

Private Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hwnd As Long, _
    ByVal lpString As String) As Long
    
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" _
    (ByVal hwnd As Long, ByVal nIndex As Long) As Long

Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
    (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" _
    (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal uMsg As Long, _
        ByVal wParam As Long, ByVal lParam As Long) As Long

Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" _
    (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private Const WM_NOTIFY = &H4E
Private Const WM_DESTROY = &H2
Private Const WM_MOVE = &H3

Private Const GWL_WNDPROC = (-4)

Private Const OLDWNDPROC = "OldWndProc"

Public Function SubClass(hwnd As Long, _
            lpfnNew As Long) As Boolean
  Dim lpfnOld As Long
  
  SubClass = True
  If GetProp(hwnd, OLDWNDPROC) Then
    Exit Function
  End If
  
  lpfnOld = SetWindowLong(hwnd, GWL_WNDPROC, lpfnNew)
  
  If lpfnOld Then
    Call SetProp(hwnd, OLDWNDPROC, lpfnOld)
  End If
  
End Function

Public Function UnSubClass(hwnd As Long) As Boolean
  Dim lpfnOld As Long
  
  lpfnOld = GetProp(hwnd, OLDWNDPROC)
  If lpfnOld Then
    
    If SetWindowLong(hwnd, GWL_WNDPROC, lpfnOld) Then
      Call RemoveProp(hwnd, OLDWNDPROC)
      
      UnSubClass = True
    
    End If   ' SetWindowLong
  End If   ' lpfnOld

End Function

Public Function WndProc(ByVal hwnd As Long, ByVal uMsg As Long, _
    ByVal wParam As Long, ByVal lParam As Long) As Long
  Dim h, l As Long
  
  Select Case uMsg
  
    Case DVA_CCCALLBACK
        h = ReverseByte(HiByte(wParam))
        l = ReverseByte(LoByte(wParam))
        h = h And &H7F
        l = l And &H7F
        Call g_CCFactory.decode(h, l)

    Case WM_MOVE
        ' Very important for overlay to work correctly.
        Call SendMessage(gVideo, uMsg, wParam, lParam)
        
    Case WM_DESTROY
      ' OLDWNDPROC will be gone after UnSubClass is called!
      Call CallWindowProc(GetProp(hwnd, OLDWNDPROC), hwnd, uMsg, wParam, lParam)
      Call UnSubClass(hwnd)
      Exit Function
      
  End Select
  
  WndProc = CallWindowProc(GetProp(hwnd, OLDWNDPROC), hwnd, uMsg, wParam, lParam)
  
End Function

Public Function ReverseByte(ByVal wData As Long) As Long
    Dim x As Long
    Dim y As Long
    Dim i As Long
    Dim res As Long
    
    res = 0
    x = 1
    y = &H80
    For i = 1 To 8
        If wData And x Then res = res Or y
        x = x * 2
        y = y / 2
    Next
    
    ReverseByte = res
End Function

Public Function HiByte(ByVal x As Long) As Long
    HiByte = (x And &HFF00) / 256
End Function

Public Function LoByte(ByVal x As Long) As Long
    LoByte = x And &HFF
End Function



